//
//            ̼(BSC)Ա
//            Baby Fox Simple Class
//
//    ̱ȨʹȨг򰮺
//
//                class FString
//

#ifndef _FString_Appeared_
#define _FString_Appeared_

#include <string.h>

class FString
{
//˽ݺ˽к
private:
    char *data;
    //ͷŶռõڴ
    void release();
public:
//ϵͳú벻Ҫע

    FString(){data=NULL;};
    FString(char *text);
    FString(const FString &other);
    FString(int character);
    ~FString();

//ת

    operator char *(){return data;}

//

    FString &operator = (char *text);
    FString &operator = (FString text);
    FString &operator = (int character);

    FString  operator + (char *text);
    FString  operator + (int character);

    FString &operator +=(char *text);
    FString &operator +=(int character);

    bool operator ==(const char *text);
    bool operator !=(const char *text);
    bool operator > (const char *text);
    bool operator < (const char *text);
    bool operator >=(const char *text);
    bool operator <=(const char *text);

    bool operator ==(FString &text){return operator ==(text.data);}
    bool operator !=(FString &text){return operator !=(text.data);}
    bool operator > (FString &text){return operator > (text.data);}
    bool operator < (FString &text){return operator < (text.data);}
    bool operator >=(FString &text){return operator >=(text.data);}
    bool operator <=(FString &text){return operator <=(text.data);}

    unsigned int operator ()(){return GetLength();}
#ifdef _tc3_dos
    char &operator [](unsigned int index){return data[index];}
#endif

//ûӿڷ

    //ַ
    char *GetData(){return data;}
    //ַ
    unsigned int GetLength();
    //㹻Ŀռ乩scanfȺʹ
    bool buffer(unsigned int Size=256);
};

//ûⲿ

unsigned int StrLen(const char *text);
FString left(char *text,unsigned int length);
FString right(char *text,unsigned int length);
FString mid(char *text,unsigned int begin,unsigned int length=0);
FString ltrim(char *text);
FString rtrim(char *text);
FString trim(char *text);
FString reverse(char *text);
FString Delete(char *text,unsigned int position,unsigned int length=1);
FString Change(char *text, char *Change, char *to);

//¸ǽӿڵľʵ֣ûбҪ˽ǵ
//ֻҪгĽӿڲʹǾ
//ĻǾ

//˽к

void FString::release()
{
    delete[] data;
}

//ϵͳúctordtor

FString::FString(char *text)
{
    data=NULL;
    operator=(text);
}

FString::FString(const FString &other)
{
    data=NULL;
    operator=(other.data);
}

FString::FString(int character)
{
    data=NULL;
    operator =(character);
}

FString::~FString()
{
    release();
}

//ַ

FString &FString::operator=(char *text)
{
	char *old=data;
    if(text==data)
        return *this;

    unsigned int length=StrLen(text);

    if(length)
    {
        data=new char[length+1];
        strcpy(data,text);
    }
    else
        data=NULL;

	delete[] old;
    return *this;
}

FString &FString::operator = (FString text)
{
    operator =(text.data);
    return *this;
}

FString &FString::operator = (int character)
{
    char *tmp;
    tmp=(char *)(&character);
    tmp[1]='\0';

    operator = (tmp);
    return *this;
}

FString FString::operator +(char *text)
{
    FString tmp;
    unsigned int length=StrLen(text);

    if((length+=GetLength())==0)
        return tmp;

    tmp.data=new char[length+1];

    if(data)
    {
        strcpy(tmp.data,data);

        if(text)
            strcat(tmp.data,text);
    }
    else
        if(text)
            strcpy(tmp.data,text);

    return tmp;
}

FString FString::operator + (int character)
{
    FString tmp;
    tmp=character;

    return operator + (tmp.data);
}

FString &FString::operator +=(char* text)
{
    char *tmp;
    unsigned int length=StrLen(text);

    if((length+=GetLength())==0)
        return *this;

    tmp=new char[length+1];

    if(data)
    {
        strcpy(tmp,data);

        if(text)
            strcat(tmp,text);
    }
    else
        if(text)
            strcpy(tmp,text);

    release();
    data=tmp;
    return *this;
}

FString &FString::operator +=(int character)
{
    FString tmp;
    tmp=character;

    operator +=(tmp.data);
    return *this;
}

//߼жϲ

bool FString::operator ==(const char *text)
{
    if(StrLen(text))
    {
        if(StrLen(data))
            return (strcmp(data,text)==0);
        else
            return false;
    }
    else
    {
        if(StrLen(data))
            return false;
        else
            return true;
    }
}

bool FString::operator !=(const char *text)
{
    return !(operator ==(text));
}

bool FString::operator >(const char *text)
{
    if(StrLen(text))
    {
        if(StrLen(data))
            return (strcmp(data,text)>0);
        else
            return false;
    }
    else
    {
        if(StrLen(data))
            return true;
        else
            return false;
    }
}

bool FString::operator <(const char *text)
{
    if(text)
    {
        if(StrLen(data))
            return (strcmp(data,text)<0);
        else
            return false;
    }
    else
        return false;
}

bool FString::operator >=(const char *text)
{
    return !(operator <(text));
}

bool FString::operator <=(const char *text)
{
    return !(operator >(text));
}

//ûӿڷ

unsigned int FString::GetLength()
{
    return StrLen(data);
}

bool FString::buffer(unsigned int newSize)
{
    release();

    if(newSize)
    {
        bool tmp=((data=new char[newSize+1])!=NULL);
        data[0]='\0';
        return tmp;
    }
    else
        return false;
}

//ûⲿ

unsigned int StrLen(const char *text)
{
    if(text)
        return strlen(text);
    else
        return 0;
}

FString left(char *text,unsigned int length)
{
    FString back;
    char *tmp;
    unsigned int textLength=StrLen(text);

    if(length>textLength||length==0)
    {
        back=text;
        return back;
    }

    tmp=new char[length+1];
    strncpy(tmp,text,length);
    tmp[length]='\0';

    back=tmp;
    delete[] tmp;
    return back;
}

FString right(char *text,unsigned int length)
{
    FString back;
    char *tmp;
    unsigned int textLength=StrLen(text);

    if(length>textLength||length==0)
    {
        back=text;
        return back;
    }

    tmp=new char[length+1];
    strncpy(tmp,&text[textLength-length],length);
    tmp[length]='\0';

    back=tmp;
    delete[] tmp;
    return back;
}

FString mid(char *text,unsigned int begin,unsigned int length)
{
    FString back;
    char *tmp;
    unsigned int textLength=StrLen(text);

    if((length>textLength-begin)||(length==0))
        length=textLength-begin;

    tmp=new char[length+1];
    strncpy(tmp,&text[begin],length);
    tmp[length]='\0';

    back=tmp;
    delete[] tmp;
    return back;
}

FString ltrim(char *text)
{
    FString back;
    unsigned int textLength=StrLen(text);

    if(textLength==0)
    {
        back="";
        return back;
    }

    while(text[0]==32)
        text++;

    back=text;
    return back;
}

FString rtrim(char *text)
{
    FString back;
    char *tmp;
    unsigned int textLength=StrLen(text);

    if(textLength==0)
    {
        back="";
        return back;
    }

    while(text[textLength-1]==32)
        textLength--;

    tmp=new char[textLength+1];
    strncpy(tmp,text,textLength);
    tmp[textLength]='\0';

    back=tmp;
    delete[] tmp;
    return back;
}

FString trim(char *text)
{
    return ltrim(rtrim(text));
}

FString reverse(char *text)
{
    FString back;
    unsigned int textLength=StrLen(text);

    if(textLength)
    {
        char *tmp=new char[textLength+1];
        for(unsigned int i=0;i<textLength;i++)
            tmp[i]=text[textLength-i-1];

        tmp[textLength]=0;
        back=tmp;

        delete[] tmp;
    }

    return back;
}

FString Delete(char *text,unsigned int position,unsigned int length)
{
    FString back;

    if(position)
        back=left(text,position);

    back+=mid(text,position+length);

    return back;
}

FString Change(char *text, char *Change, char *to)
{
    FString myString;

    if(StrLen(text)<StrLen(Change))
        return FString(text);
    else if(FString(text)==Change)
        return FString(to);

    for(unsigned int i=0; i<StrLen(text)-StrLen(Change)+1; i++)
    {
        if(left(text+i, StrLen(Change))==Change)
        {
            myString+=to;
            i+=StrLen(Change)-1;
        }
        else
            myString+=text[i];
    }

    myString+=(text+i);
    return myString;
}

FString Duplicate(char *text, unsigned int n)
{
    FString temp;
    unsigned int Length;

    if((Length=StrLen(text))==0)
        return temp;

    temp.buffer(n*Length);
    for(unsigned int i=0; i<n; i++)
        strcat(temp, text);

    return temp;
}

#endif
